<?php
if (session_status() == PHP_SESSION_NONE) {
    session_start();
}
if(isset($_GET['US'])){
    $_SESSION["authID"] = $_GET['US'];
}
if (!isset($_SESSION["authID"])) {
    header("Location: ../../login");
    exit();
}
// Set your secret key. Remember to switch to your live secret key in production.
// Include the Stripe PHP library
require_once dirname(dirname(__FILE__),2) . '/variables/variablesClass.php';
require_once dirname(dirname(__FILE__),2) . '/stripe/stripe/init.php';
require_once dirname(dirname(__FILE__)) . '/terminal/classes/termEmail.php';
require_once dirname(dirname(__FILE__)) . '/terminal/classes/terminal.php';
require_once dirname(dirname(__FILE__)) . '/terminal/classes/termPdf.php';
require_once dirname(dirname(__FILE__),2) . '/POS/classes/pos.php';
;
// See your keys here: https://dashboard.stripe.com/apikeys

$terminal = new terminal();
$payment_intent = null;

$stripe = new \Stripe\StripeClient($terminal->getApiKey());
\Stripe\Stripe::setApiKey($terminal->getApiKey());

if(isset($_POST['amount'])){
    unset($_SESSION['prevStatusMessage']);
//    echo 'Result post: '.print_r($_POST);
    echo '<script>window.top.document.getElementById("sendToTerminal").style.display = "none";</script>';
    if(isset($_POST['posInput'])){
        echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "inline-block";</script>';
    }
//    echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "none";</script>';
//    echo '<script>window.top.document.getElementById("viewRecieptForm").style.display = "inline-block";</script>';
    //cancelTerminal
    $amountDecimal = str_replace('$', '', $_POST['amount']);
    $amountSplit = explode(".",$amountDecimal);
    $amountDollars = $amountSplit[0];
    if(isset($amountSplit[1])){
        $amountCents = $amountSplit[1];
        switch (strlen($amountCents)) {
            case 0:
                $amountCents = '00';
            case 1:
                $amountCents = $amountCents .= '0';
            default:
                $amountCents = substr($amountCents, 0, 2);
        }
    }else{
        $amountCents = '00';
    }
    try {
        $location = $_POST['programLocation'];
        $description = $_POST['description'];
        $invoiceID = '';
        if($description == ''){
            if($location == 'posTerminal'){
                $description = "POS Purchase";
                $invoiceID = 'POS';
            }else {
                $description = "Terminal Purchase";
                $invoiceID = 'Terminal';
            }
        }
        echo '<script>window.top.document.getElementById("pid").innerText = ""</script>';
        //$amount = str_replace('.', '', $amountDecimal);
        $amount = $amountDollars . $amountCents;
//        $stripe->terminal->configurations->create([
//            'tipping' => [
//                'usd' => [
//                    'percentages' => [10, 15, 20],
//                    'fixed_amounts' => [100, 150, 200],
//                    'smart_tip_threshold' => 1000,
//                ],
//            ],
//        ]);
//        $stripe->terminal->configurations->update(
//            $_POST['readerId'],
//            [
//                'tipping' => [
//                    'usd' => [
//                        'percentages' => [15, 20, 25],
//                        'fixed_amounts' => [100, 150, 200],
//                        'smart_tip_threshold' => 1000,
//                    ],
//                ],
//            ]
//        );

        if(isset($_SESSION['userID'])){
            $userID = $_SESSION['userID'];
        }else {
            $userID = 0;
        }
        $payment_intent = $stripe->paymentIntents->create([
            'currency' => 'usd',
            'payment_method_types' => ['card_present'],
            'capture_method' => 'manual',
            'amount' => $amount,
            'description' => $description,
            'metadata' => [
                'userId' => $userID,
                'programLocation' => $location,
                'invoice_id' => $invoiceID,
            ],
        ]);
    }
    catch (Exception $e){
        message('Error: '. $e->getMessage());
        exit();
    }

    try {
        if(isset($_POST['readerId'])){
            $stripe->terminal->readers->processPaymentIntent(
                $_POST['readerId'],
                [
                    'payment_intent' => $payment_intent->id,
                    'process_config' => ['enable_customer_cancellation' => true],
                ]
            );
        }else{
            throw new Exception("No Terminal selected");
        }

        //$_SESSION['payIntent'] = $payment_intent->id;
        echo '<script>window.top.document.getElementById("pid").innerText = "'.$payment_intent->id.'"</script>';
    }

    catch (Exception $e){
        message('Connection Error: Make sure the Reader is powered on and connected to the WIFI');
        echo '<script>window.top.document.getElementById("sendToTerminal").style.display = "inline-block";</script>';
        if(isset($_POST['posInput'])){
            echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "none";</script>';
        }
    }
    try {
        $status = $stripe->terminal->readers->retrieve($_POST['readerId'], []);
        if($status['status'] == "online"){
            $amountConv = $amount / 100;
            message('$'.number_format(floatval($amountConv),2).' Sent to Terminal');
            unset($_SESSION['sendReciept']);
        }else{
            message($status['status']);
            echo '<script>window.top.document.getElementById("sendToTerminal").style.display = "inline-block";</script>';
            if(isset($_POST['posInput'])){
                echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "none";</script>';
            }
        }
    }
    catch (Exception $e){
        message('Error: '. $e->getMessage());
        echo '<script>window.top.document.getElementById("sendToTerminal").style.display = "inline-block";</script>';
        if(isset($_POST['posInput'])){
            echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "none";</script>';
        }
    }

}

//if(isset($_POST['processPayment'])){
//
//    if(isset($_SESSION['payIntent'])){
//
//        if(displayResults($stripe, $_SESSION['payIntent'])){
//            message('Processing Payment');
//        }else{
//            message('Check Other logs');
//            unset($_SESSION['payIntent']);
//        }
//    }
//}

if(isset($_POST['cancel'])){
    cancelReader($stripe,$_POST['readerId'] );
    //unset($_SESSION['payIntent']);
}

function cancelReader($stripe, $readerID){
    $stripe->terminal->readers->cancelAction($readerID, []);
    //unset($_SESSION['payIntent']);
    echo '<script>window.top.document.getElementById("pid").value = ""</script>';
    echo '<script>window.top.document.getElementById("cancelTerminal").style.display = "none";</script>';
    echo '<script>window.top.document.getElementById("sendToTerminal").style.display = "inline-block";</script>';
    echo '<script>window.top.cancelStatusCheck()</script>';
}

function displayResults($stripe, $paymentIntentId){
    $terminal = new terminal();
    $terminaObj = $terminal->findResults($paymentIntentId);
                    if($terminaObj != ''){
                        $terminal->setTerminalStatusUserID($_SESSION["userID"]);
                        $terminal->updateUid();
                        message(' Result: '.$terminaObj->getTerminalStatusCode().'<br> Message: '.$terminaObj->getTerminalStatusMessage());
                        //echo 'Result: '.$terminaObj->getTerminalStatusCode().'<br> Message: '.$terminaObj->getTerminalStatusMessage();
                        if($terminaObj->getTerminalStatusMessage() == "succeeded"){
                            $terminaObj->findAllTerminalPurchaseData($paymentIntentId);
                            completeShowReciept($terminaObj);
                            //if POS
                            //erase Shoppting cart for sale
                        }
                        cancelReader($stripe,$terminaObj->getTerminalPurchasesTerminalId() );
                        return true;
                    }
              return false;
}

function displayPOSResults($stripe, $paymentIntentId){
    $pos = new pos();
    $posObj = $pos->findResults($paymentIntentId);
    if($posObj != ''){
        $pos->setPosStatusUserID($_SESSION["userID"]);
        $pos->updateUid();
        message(' Result: '.$posObj->getPosStatusCode().'<br> Message: '.$posObj->getPosStatusMessage());
        //echo 'Result: '.$terminaObj->getTerminalStatusCode().'<br> Message: '.$terminaObj->getTerminalStatusMessage();
        if($posObj->getPosStatusMessage() == "succeeded"){
            //$posObj->findAllPosPurchaseData($paymentIntentId);
            //completeShowReciept($posObj);
            //if POS
            //erase Shoppting cart for sale
        }
        cancelReader($stripe,$posObj->getPosPurchasesPosId() );
        return true;
    }
    return false;
}

if(isset($_POST['requestResults'])){

    if(isset($_POST['pid'])){
        if(isset($_POST['pos'])){
            displayPOSResults($stripe, $_POST['pid']);
        }else {
            displayResults($stripe, $_POST['pid']);
        }

    }

}

function completeShowReciept($terminal){
    $vars = new variables();
    echo '<script>parent.showReciept("' . $vars->getWebURL() . '","' . $terminal->getTerminalPurchasesFileName() . '");</script>';
}

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="stylesheet" type="text/css" href="css/terminal.css" />
    <title>CC Terminal</title>
</head>
<body>

<?php
if (isset($_POST['sessionValue'])) {
    $_SESSION['prevStatusMessage'] = $_POST['sessionValue'];
    message($_SESSION['prevStatusMessage']);
}

if(isset($_SESSION['prevStatusMessage'])){
    message($_SESSION['prevStatusMessage']);
}

 function message($message){
     echo '<h3 id="statusMessage" class="statusMessage">'.$message.'</h3>';
 }
?>

</body>
</html>